#include "assets.hpp"
#include <PSX/GPU/gpu_primitives.hpp>
#include <PSX/GPU/gpu.hpp>
#include <stdio.h>

using namespace JabyEngine;
static auto FontPage = GPU::TexPage({Assets::FontTIM.get_texture_x(), Assets::FontTIM.get_texture_y()}, GPU::TexturePageColor::$4bit).linked();
static auto FontTest = GPU::SPRT(
    GPU::AreaI16({0, 0}, {256, 96}), {GPU::PagePosition(0, 0), GPU::PageClut(Assets::FontTIM.get_clut_x(), Assets::FontTIM.get_clut_y())}, 
    GPU::Color24::Grey()
).linked();
static auto FontTestColor = GPU::SPRT(
    GPU::AreaI16({0, 96}, {256, 96}), {GPU::PagePosition(0, 0), GPU::PageClut(Assets::FontTIM.get_clut_x(), Assets::FontTIM.get_clut_y())}, 
    GPU::Color24(0x0, 0x0, 0xA0)
).linked();

void main() {
    Assets::load_for_main();
    
    FontPage.concat(FontTest).concat(FontTestColor);
    while(true) {
        GPU::swap_buffers_vsync(1);
        GPU::render(FontPage);
    }
}